diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-router-interface.cc ns-3.47/src/internet/model/global-router-interface.cc
--- ns-3.46/src/internet/model/global-router-interface.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-router-interface.cc	2026-02-16 16:08:49.611230000 -0800
@@ -8,7 +8,7 @@
 
 #include "global-router-interface.h"
 
-#include "ipv4-global-routing.h"
+#include "global-routing.h"
 #include "ipv4.h"
 #include "loopback-net-device.h"
 
@@ -20,6 +20,7 @@
 #include "ns3/net-device.h"
 #include "ns3/node-list.h"
 #include "ns3/node.h"
+#include "ns3/object-base.h"
 
 #include <vector>
 
@@ -34,100 +35,145 @@
 //
 // ---------------------------------------------------------------------------
 
-GlobalRoutingLinkRecord::GlobalRoutingLinkRecord()
-    : m_linkId("0.0.0.0"),
-      m_linkData("0.0.0.0"),
+template <typename T>
+GlobalRoutingLinkRecord<T>::GlobalRoutingLinkRecord()
+    : m_linkId(IpAddress::GetZero()),
+      m_linkData(IpAddress::GetZero()),
+      m_linkLocData(IpAddress::GetZero()),
       m_linkType(Unknown),
       m_metric(0)
 {
     NS_LOG_FUNCTION(this);
 }
 
-GlobalRoutingLinkRecord::GlobalRoutingLinkRecord(LinkType linkType,
-                                                 Ipv4Address linkId,
-                                                 Ipv4Address linkData,
-                                                 uint16_t metric)
+template <typename T>
+GlobalRoutingLinkRecord<T>::GlobalRoutingLinkRecord(LinkType linkType,
+                                                    IpAddress linkId,
+                                                    IpAddress linkData,
+                                                    uint16_t metric)
     : m_linkId(linkId),
       m_linkData(linkData),
+      m_linkLocData(IpAddress::GetZero()),
       m_linkType(linkType),
       m_metric(metric)
 {
     NS_LOG_FUNCTION(this << linkType << linkId << linkData << metric);
 }
 
-GlobalRoutingLinkRecord::~GlobalRoutingLinkRecord()
+template <typename T>
+GlobalRoutingLinkRecord<T>::GlobalRoutingLinkRecord(LinkType linkType,
+                                                    IpAddress linkId,
+                                                    IpAddress linkData,
+                                                    IpAddress linkLocData,
+                                                    uint16_t metric)
+    : m_linkId(linkId),
+      m_linkData(linkData),
+      m_linkLocData(linkLocData),
+      m_linkType(linkType),
+      m_metric(metric)
+{
+    NS_LOG_FUNCTION(this << m_linkId << m_linkData << m_linkType << m_linkLocData << m_metric);
+}
+
+template <typename T>
+GlobalRoutingLinkRecord<T>::~GlobalRoutingLinkRecord()
 {
     NS_LOG_FUNCTION(this);
 }
 
-Ipv4Address
-GlobalRoutingLinkRecord::GetLinkId() const
+template <typename T>
+GlobalRoutingLinkRecord<T>::IpAddress
+GlobalRoutingLinkRecord<T>::GetLinkId() const
 {
     NS_LOG_FUNCTION(this);
     return m_linkId;
 }
 
+template <typename T>
 void
-GlobalRoutingLinkRecord::SetLinkId(Ipv4Address addr)
+GlobalRoutingLinkRecord<T>::SetLinkId(IpAddress addr)
 {
     NS_LOG_FUNCTION(this << addr);
     m_linkId = addr;
 }
 
-Ipv4Address
-GlobalRoutingLinkRecord::GetLinkData() const
+template <typename T>
+GlobalRoutingLinkRecord<T>::IpAddress
+GlobalRoutingLinkRecord<T>::GetLinkData() const
 {
     NS_LOG_FUNCTION(this);
     return m_linkData;
 }
 
+template <typename T>
 void
-GlobalRoutingLinkRecord::SetLinkData(Ipv4Address addr)
+GlobalRoutingLinkRecord<T>::SetLinkData(GlobalRoutingLinkRecord<T>::IpAddress addr)
 {
     NS_LOG_FUNCTION(this << addr);
     m_linkData = addr;
 }
 
-GlobalRoutingLinkRecord::LinkType
-GlobalRoutingLinkRecord::GetLinkType() const
+template <typename T>
+GlobalRoutingLinkRecord<T>::LinkType
+GlobalRoutingLinkRecord<T>::GetLinkType() const
 {
     NS_LOG_FUNCTION(this);
     return m_linkType;
 }
 
+template <typename T>
 void
-GlobalRoutingLinkRecord::SetLinkType(GlobalRoutingLinkRecord::LinkType linkType)
+GlobalRoutingLinkRecord<T>::SetLinkType(GlobalRoutingLinkRecord::LinkType linkType)
 {
     NS_LOG_FUNCTION(this << linkType);
     m_linkType = linkType;
 }
 
+template <typename T>
 uint16_t
-GlobalRoutingLinkRecord::GetMetric() const
+GlobalRoutingLinkRecord<T>::GetMetric() const
 {
     NS_LOG_FUNCTION(this);
     return m_metric;
 }
 
+template <typename T>
 void
-GlobalRoutingLinkRecord::SetMetric(uint16_t metric)
+GlobalRoutingLinkRecord<T>::SetMetric(uint16_t metric)
 {
     NS_LOG_FUNCTION(this << metric);
     m_metric = metric;
 }
 
+template <typename T>
+void
+GlobalRoutingLinkRecord<T>::SetLinkLocData(IpAddress linkLocData)
+{
+    NS_LOG_FUNCTION(this << linkLocData);
+    m_linkLocData = linkLocData;
+}
+
+template <typename T>
+GlobalRoutingLinkRecord<T>::IpAddress
+GlobalRoutingLinkRecord<T>::GetLinkLocData()
+{
+    NS_LOG_FUNCTION(this);
+    return m_linkLocData;
+}
+
 // ---------------------------------------------------------------------------
 //
 // GlobalRoutingLSA Implementation
 //
 // ---------------------------------------------------------------------------
 
-GlobalRoutingLSA::GlobalRoutingLSA()
+template <typename T>
+GlobalRoutingLSA<T>::GlobalRoutingLSA()
     : m_lsType(GlobalRoutingLSA::Unknown),
-      m_linkStateId("0.0.0.0"),
-      m_advertisingRtr("0.0.0.0"),
+      m_linkStateId(IpAddress::GetZero()),
+      m_advertisingRtr(IpAddress::GetZero()),
       m_linkRecords(),
-      m_networkLSANetworkMask("0.0.0.0"),
+      m_networkLSANetworkMask(IpMaskOrPrefix::GetZero()),
       m_attachedRouters(),
       m_status(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED),
       m_node_id(0)
@@ -135,14 +181,15 @@
     NS_LOG_FUNCTION(this);
 }
 
-GlobalRoutingLSA::GlobalRoutingLSA(GlobalRoutingLSA::SPFStatus status,
-                                   Ipv4Address linkStateId,
-                                   Ipv4Address advertisingRtr)
+template <typename T>
+GlobalRoutingLSA<T>::GlobalRoutingLSA(GlobalRoutingLSA::SPFStatus status,
+                                      IpAddress linkStateId,
+                                      IpAddress advertisingRtr)
     : m_lsType(GlobalRoutingLSA::Unknown),
       m_linkStateId(linkStateId),
       m_advertisingRtr(advertisingRtr),
       m_linkRecords(),
-      m_networkLSANetworkMask("0.0.0.0"),
+      m_networkLSANetworkMask(IpMaskOrPrefix::GetZero()),
       m_attachedRouters(),
       m_status(status),
       m_node_id(0)
@@ -150,7 +197,8 @@
     NS_LOG_FUNCTION(this << status << linkStateId << advertisingRtr);
 }
 
-GlobalRoutingLSA::GlobalRoutingLSA(GlobalRoutingLSA& lsa)
+template <typename T>
+GlobalRoutingLSA<T>::GlobalRoutingLSA(GlobalRoutingLSA& lsa)
     : m_lsType(lsa.m_lsType),
       m_linkStateId(lsa.m_linkStateId),
       m_advertisingRtr(lsa.m_advertisingRtr),
@@ -163,8 +211,9 @@
     CopyLinkRecords(lsa);
 }
 
-GlobalRoutingLSA&
-GlobalRoutingLSA::operator=(const GlobalRoutingLSA& lsa)
+template <typename T>
+GlobalRoutingLSA<T>&
+GlobalRoutingLSA<T>::operator=(const GlobalRoutingLSA<T>& lsa)
 {
     NS_LOG_FUNCTION(this << &lsa);
     m_lsType = lsa.m_lsType;
@@ -178,18 +227,20 @@
     return *this;
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::CopyLinkRecords(const GlobalRoutingLSA& lsa)
+GlobalRoutingLSA<T>::CopyLinkRecords(const GlobalRoutingLSA& lsa)
 {
     NS_LOG_FUNCTION(this << &lsa);
     for (auto i = lsa.m_linkRecords.begin(); i != lsa.m_linkRecords.end(); i++)
     {
-        GlobalRoutingLinkRecord* pSrc = *i;
-        auto pDst = new GlobalRoutingLinkRecord;
+        GlobalRoutingLinkRecord<T>* pSrc = *i;
+        auto pDst = new GlobalRoutingLinkRecord<T>;
 
         pDst->SetLinkType(pSrc->GetLinkType());
         pDst->SetLinkId(pSrc->GetLinkId());
         pDst->SetLinkData(pSrc->GetLinkData());
+        pDst->SetLinkLocData(pSrc->GetLinkLocData());
         pDst->SetMetric(pSrc->GetMetric());
 
         m_linkRecords.push_back(pDst);
@@ -199,21 +250,23 @@
     m_attachedRouters = lsa.m_attachedRouters;
 }
 
-GlobalRoutingLSA::~GlobalRoutingLSA()
+template <typename T>
+GlobalRoutingLSA<T>::~GlobalRoutingLSA()
 {
     NS_LOG_FUNCTION(this);
     ClearLinkRecords();
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::ClearLinkRecords()
+GlobalRoutingLSA<T>::ClearLinkRecords()
 {
     NS_LOG_FUNCTION(this);
     for (auto i = m_linkRecords.begin(); i != m_linkRecords.end(); i++)
     {
         NS_LOG_LOGIC("Free link record");
 
-        GlobalRoutingLinkRecord* p = *i;
+        GlobalRoutingLinkRecord<T>* p = *i;
         delete p;
         p = nullptr;
 
@@ -223,23 +276,26 @@
     m_linkRecords.clear();
 }
 
+template <typename T>
 uint32_t
-GlobalRoutingLSA::AddLinkRecord(GlobalRoutingLinkRecord* lr)
+GlobalRoutingLSA<T>::AddLinkRecord(GlobalRoutingLinkRecord<T>* lr)
 {
     NS_LOG_FUNCTION(this << lr);
     m_linkRecords.push_back(lr);
     return m_linkRecords.size();
 }
 
+template <typename T>
 uint32_t
-GlobalRoutingLSA::GetNLinkRecords() const
+GlobalRoutingLSA<T>::GetNLinkRecords() const
 {
     NS_LOG_FUNCTION(this);
     return m_linkRecords.size();
 }
 
-GlobalRoutingLinkRecord*
-GlobalRoutingLSA::GetLinkRecord(uint32_t n) const
+template <typename T>
+GlobalRoutingLinkRecord<T>*
+GlobalRoutingLSA<T>::GetLinkRecord(uint32_t n) const
 {
     NS_LOG_FUNCTION(this << n);
     uint32_t j = 0;
@@ -254,93 +310,106 @@
     return nullptr;
 }
 
+template <typename T>
 bool
-GlobalRoutingLSA::IsEmpty() const
+GlobalRoutingLSA<T>::IsEmpty() const
 {
     NS_LOG_FUNCTION(this);
     return m_linkRecords.empty();
 }
 
-GlobalRoutingLSA::LSType
-GlobalRoutingLSA::GetLSType() const
+template <typename T>
+GlobalRoutingLSA<T>::LSType
+GlobalRoutingLSA<T>::GetLSType() const
 {
     NS_LOG_FUNCTION(this);
     return m_lsType;
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::SetLSType(GlobalRoutingLSA::LSType typ)
+GlobalRoutingLSA<T>::SetLSType(GlobalRoutingLSA::LSType typ)
 {
     NS_LOG_FUNCTION(this << typ);
     m_lsType = typ;
 }
 
-Ipv4Address
-GlobalRoutingLSA::GetLinkStateId() const
+template <typename T>
+GlobalRoutingLSA<T>::IpAddress
+GlobalRoutingLSA<T>::GetLinkStateId() const
 {
     NS_LOG_FUNCTION(this);
     return m_linkStateId;
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::SetLinkStateId(Ipv4Address addr)
+GlobalRoutingLSA<T>::SetLinkStateId(IpAddress addr)
 {
     NS_LOG_FUNCTION(this << addr);
     m_linkStateId = addr;
 }
 
-Ipv4Address
-GlobalRoutingLSA::GetAdvertisingRouter() const
+template <typename T>
+GlobalRoutingLSA<T>::IpAddress
+GlobalRoutingLSA<T>::GetAdvertisingRouter() const
 {
     NS_LOG_FUNCTION(this);
     return m_advertisingRtr;
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::SetAdvertisingRouter(Ipv4Address addr)
+GlobalRoutingLSA<T>::SetAdvertisingRouter(IpAddress addr)
 {
     NS_LOG_FUNCTION(this << addr);
     m_advertisingRtr = addr;
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::SetNetworkLSANetworkMask(Ipv4Mask mask)
+GlobalRoutingLSA<T>::SetNetworkLSANetworkMask(IpMaskOrPrefix mask)
 {
     NS_LOG_FUNCTION(this << mask);
     m_networkLSANetworkMask = mask;
 }
 
-Ipv4Mask
-GlobalRoutingLSA::GetNetworkLSANetworkMask() const
+template <typename T>
+GlobalRoutingLSA<T>::IpMaskOrPrefix
+GlobalRoutingLSA<T>::GetNetworkLSANetworkMask() const
 {
     NS_LOG_FUNCTION(this);
     return m_networkLSANetworkMask;
 }
 
-GlobalRoutingLSA::SPFStatus
-GlobalRoutingLSA::GetStatus() const
+template <typename T>
+GlobalRoutingLSA<T>::SPFStatus
+GlobalRoutingLSA<T>::GetStatus() const
 {
     NS_LOG_FUNCTION(this);
     return m_status;
 }
 
+template <typename T>
 uint32_t
-GlobalRoutingLSA::AddAttachedRouter(Ipv4Address addr)
+GlobalRoutingLSA<T>::AddAttachedRouter(IpAddress addr)
 {
     NS_LOG_FUNCTION(this << addr);
     m_attachedRouters.push_back(addr);
     return m_attachedRouters.size();
 }
 
+template <typename T>
 uint32_t
-GlobalRoutingLSA::GetNAttachedRouters() const
+GlobalRoutingLSA<T>::GetNAttachedRouters() const
 {
     NS_LOG_FUNCTION(this);
     return m_attachedRouters.size();
 }
 
-Ipv4Address
-GlobalRoutingLSA::GetAttachedRouter(uint32_t n) const
+template <typename T>
+GlobalRoutingLSA<T>::IpAddress
+GlobalRoutingLSA<T>::GetAttachedRouter(uint32_t n) const
 {
     NS_LOG_FUNCTION(this << n);
     uint32_t j = 0;
@@ -352,32 +421,36 @@
         }
     }
     NS_ASSERT_MSG(false, "GlobalRoutingLSA::GetAttachedRouter (): invalid index");
-    return Ipv4Address("0.0.0.0");
+    return IpAddress::GetZero();
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::SetStatus(GlobalRoutingLSA::SPFStatus status)
+GlobalRoutingLSA<T>::SetStatus(GlobalRoutingLSA::SPFStatus status)
 {
     NS_LOG_FUNCTION(this << status);
     m_status = status;
 }
 
+template <typename T>
 Ptr<Node>
-GlobalRoutingLSA::GetNode() const
+GlobalRoutingLSA<T>::GetNode() const
 {
     NS_LOG_FUNCTION(this);
     return NodeList::GetNode(m_node_id);
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::SetNode(Ptr<Node> node)
+GlobalRoutingLSA<T>::SetNode(Ptr<Node> node)
 {
     NS_LOG_FUNCTION(this << node);
     m_node_id = node->GetId();
 }
 
+template <typename T>
 void
-GlobalRoutingLSA::Print(std::ostream& os) const
+GlobalRoutingLSA<T>::Print(std::ostream& os) const
 {
     NS_LOG_FUNCTION(this << &os);
     os << std::endl;
@@ -408,18 +481,18 @@
     {
         for (auto i = m_linkRecords.begin(); i != m_linkRecords.end(); i++)
         {
-            GlobalRoutingLinkRecord* p = *i;
+            GlobalRoutingLinkRecord<T>* p = *i;
 
             os << "---------- RouterLSA Link Record ----------" << std::endl;
             os << "m_linkType = " << p->m_linkType;
-            if (p->m_linkType == GlobalRoutingLinkRecord::PointToPoint)
+            if (p->m_linkType == GlobalRoutingLinkRecord<T>::PointToPoint)
             {
                 os << " (GlobalRoutingLinkRecord::PointToPoint)" << std::endl;
                 os << "m_linkId = " << p->m_linkId << std::endl;
                 os << "m_linkData = " << p->m_linkData << std::endl;
                 os << "m_metric = " << p->m_metric << std::endl;
             }
-            else if (p->m_linkType == GlobalRoutingLinkRecord::TransitNetwork)
+            else if (p->m_linkType == GlobalRoutingLinkRecord<T>::TransitNetwork)
             {
                 os << " (GlobalRoutingLinkRecord::TransitNetwork)" << std::endl;
                 os << "m_linkId = " << p->m_linkId << " (Designated router for network)"
@@ -428,7 +501,7 @@
                    << std::endl;
                 os << "m_metric = " << p->m_metric << std::endl;
             }
-            else if (p->m_linkType == GlobalRoutingLinkRecord::StubNetwork)
+            else if (p->m_linkType == GlobalRoutingLinkRecord<T>::StubNetwork)
             {
                 os << " (GlobalRoutingLinkRecord::StubNetwork)" << std::endl;
                 os << "m_linkId = " << p->m_linkId << " (Network number of attached network)"
@@ -453,8 +526,7 @@
         os << "m_networkLSANetworkMask = " << m_networkLSANetworkMask << std::endl;
         for (auto i = m_attachedRouters.begin(); i != m_attachedRouters.end(); i++)
         {
-            Ipv4Address p = *i;
-            os << "attachedRouter = " << p << std::endl;
+            os << "attachedRouter = " << *i << std::endl;
         }
         os << "---------- End NetworkLSA Link Record ----------" << std::endl;
     }
@@ -471,8 +543,9 @@
     os << "========== End Global Routing LSA ==========" << std::endl;
 }
 
+template <typename T>
 std::ostream&
-operator<<(std::ostream& os, GlobalRoutingLSA& lsa)
+operator<<(std::ostream& os, GlobalRoutingLSA<T>& lsa)
 {
     lsa.Print(os);
     return os;
@@ -484,44 +557,70 @@
 //
 // ---------------------------------------------------------------------------
 
-NS_OBJECT_ENSURE_REGISTERED(GlobalRouter);
-
+template <typename T>
 TypeId
-GlobalRouter::GetTypeId()
+GlobalRouter<T>::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::GlobalRouter").SetParent<Object>().SetGroupName("Internet");
+    std::string name;
+    if constexpr (IsIpv4)
+    {
+        name = "Ipv4";
+    }
+    else
+    {
+        name = "Ipv6";
+    }
+    static TypeId tid = TypeId("ns3::" + name + "GlobalRouter")
+                            .SetParent<Object>()
+                            .SetGroupName("GlobalRouter")
+                            .template AddConstructor<GlobalRouter<T>>();
     return tid;
 }
 
-GlobalRouter::GlobalRouter()
+template <typename T>
+GlobalRouter<T>::GlobalRouter()
     : m_LSAs()
 {
     NS_LOG_FUNCTION(this);
-    m_routerId.Set(GlobalRouteManager::AllocateRouterId());
+    if constexpr (IsIpv4)
+    {
+        m_routerId.Set(Ipv4GlobalRouteManager::AllocateRouterId());
+    }
+    else
+    {
+        // looks ugly but gets the job done .
+        // Alternatively, convert uint32_t to a uint8_t buf[16] and then use  Ipv6Address(buf)
+        m_routerId = Ipv6Address::MakeIpv4MappedAddress(
+            Ipv4Address(GlobalRouteManager<Ipv6Manager>::AllocateRouterId()));
+    }
 }
 
-GlobalRouter::~GlobalRouter()
+template <typename T>
+GlobalRouter<T>::~GlobalRouter()
 {
     NS_LOG_FUNCTION(this);
     ClearLSAs();
 }
 
+template <typename T>
 void
-GlobalRouter::SetRoutingProtocol(Ptr<Ipv4GlobalRouting> routing)
+GlobalRouter<T>::SetRoutingProtocol(Ptr<GlobalRouting<IpRoutingProtocol>> routing)
 {
     NS_LOG_FUNCTION(this << routing);
     m_routingProtocol = routing;
 }
 
-Ptr<Ipv4GlobalRouting>
-GlobalRouter::GetRoutingProtocol()
+template <typename T>
+Ptr<GlobalRouting<typename GlobalRouter<T>::IpRoutingProtocol>>
+GlobalRouter<T>::GetRoutingProtocol()
 {
     NS_LOG_FUNCTION(this);
     return m_routingProtocol;
 }
 
+template <typename T>
 void
-GlobalRouter::DoDispose()
+GlobalRouter<T>::DoDispose()
 {
     NS_LOG_FUNCTION(this);
     m_routingProtocol = nullptr;
@@ -533,15 +632,16 @@
     Object::DoDispose();
 }
 
+template <typename T>
 void
-GlobalRouter::ClearLSAs()
+GlobalRouter<T>::ClearLSAs()
 {
     NS_LOG_FUNCTION(this);
     for (auto i = m_LSAs.begin(); i != m_LSAs.end(); i++)
     {
         NS_LOG_LOGIC("Free LSA");
 
-        GlobalRoutingLSA* p = *i;
+        GlobalRoutingLSA<T>* p = *i;
         delete p;
         p = nullptr;
 
@@ -551,8 +651,9 @@
     m_LSAs.clear();
 }
 
-Ipv4Address
-GlobalRouter::GetRouterId() const
+template <typename T>
+GlobalRouter<T>::IpAddress
+GlobalRouter<T>::GetRouterId() const
 {
     NS_LOG_FUNCTION(this);
     return m_routerId;
@@ -564,8 +665,9 @@
 // and build the Link State Advertisements that reflect them and their associated
 // networks.
 //
+template <typename T>
 uint32_t
-GlobalRouter::DiscoverLSAs()
+GlobalRouter<T>::DiscoverLSAs()
 {
     NS_LOG_FUNCTION(this);
     Ptr<Node> node = GetObject<Node>();
@@ -587,18 +689,18 @@
     // Ipv4 interface.  This is where the information regarding the attached
     // interfaces lives.  If we're a router, we had better have an Ipv4 interface.
     //
-    Ptr<Ipv4> ipv4Local = node->GetObject<Ipv4>();
-    NS_ABORT_MSG_UNLESS(ipv4Local,
+    Ptr<Ip> ipLocal = node->GetObject<Ip>();
+    NS_ABORT_MSG_UNLESS(ipLocal,
                         "GlobalRouter::DiscoverLSAs (): GetObject for <Ipv4> interface failed");
 
     //
     // Every router node originates a Router-LSA
     //
-    auto pLSA = new GlobalRoutingLSA;
-    pLSA->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto pLSA = new GlobalRoutingLSA<T>;
+    pLSA->SetLSType(GlobalRoutingLSA<T>::RouterLSA);
     pLSA->SetLinkStateId(m_routerId);
     pLSA->SetAdvertisingRouter(m_routerId);
-    pLSA->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+    pLSA->SetStatus(GlobalRoutingLSA<T>::LSA_SPF_NOT_EXPLORED);
     pLSA->SetNode(node);
 
     //
@@ -629,7 +731,7 @@
         //
         if (NetDeviceIsBridged(ndLocal))
         {
-            int32_t ifIndex = ipv4Local->GetInterfaceForDevice(ndLocal);
+            int32_t ifIndex = ipLocal->GetInterfaceForDevice(ndLocal);
             NS_ABORT_MSG_IF(
                 ifIndex != -1,
                 "GlobalRouter::DiscoverLSAs(): Bridge ports must not have an IPv4 interface index");
@@ -641,9 +743,9 @@
         // associated with a bridge.  We are only going to involve devices with
         // IP addresses in routing.
         //
-        int32_t interfaceNumber = ipv4Local->GetInterfaceForDevice(ndLocal);
+        int32_t interfaceNumber = ipLocal->GetInterfaceForDevice(ndLocal);
         if (interfaceNumber == -1 ||
-            !(ipv4Local->IsUp(interfaceNumber) && ipv4Local->IsForwarding(interfaceNumber)))
+            !(ipLocal->IsUp(interfaceNumber) && ipLocal->IsForwarding(interfaceNumber)))
         {
             NS_LOG_LOGIC("Net device "
                          << ndLocal
@@ -699,19 +801,29 @@
     //
     for (auto i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
     {
-        auto pLSA = new GlobalRoutingLSA;
-        pLSA->SetLSType(GlobalRoutingLSA::ASExternalLSAs);
+        auto pLSA = new GlobalRoutingLSA<T>;
+        pLSA->SetLSType(GlobalRoutingLSA<T>::ASExternalLSAs);
         pLSA->SetLinkStateId((*i)->GetDestNetwork());
         pLSA->SetAdvertisingRouter(m_routerId);
-        pLSA->SetNetworkLSANetworkMask((*i)->GetDestNetworkMask());
-        pLSA->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+        if constexpr (IsIpv4)
+        {
+            pLSA->SetNetworkLSANetworkMask((*i)->GetDestNetworkMask());
+        }
+        else
+        {
+            pLSA->SetNetworkLSANetworkMask((*i)->GetDestNetworkPrefix());
+        }
+        pLSA->SetStatus(GlobalRoutingLSA<T>::LSA_SPF_NOT_EXPLORED);
         m_LSAs.push_back(pLSA);
     }
     return m_LSAs.size();
 }
 
+template <typename T>
 void
-GlobalRouter::ProcessBroadcastLink(Ptr<NetDevice> nd, GlobalRoutingLSA* pLSA, NetDeviceContainer& c)
+GlobalRouter<T>::ProcessBroadcastLink(Ptr<NetDevice> nd,
+                                      GlobalRoutingLSA<T>* pLSA,
+                                      NetDeviceContainer& c)
 {
     NS_LOG_FUNCTION(this << nd << pLSA << &c);
 
@@ -725,14 +837,15 @@
     }
 }
 
+template <typename T>
 void
-GlobalRouter::ProcessSingleBroadcastLink(Ptr<NetDevice> nd,
-                                         GlobalRoutingLSA* pLSA,
-                                         NetDeviceContainer& c)
+GlobalRouter<T>::ProcessSingleBroadcastLink(Ptr<NetDevice> nd,
+                                            GlobalRoutingLSA<T>* pLSA,
+                                            NetDeviceContainer& c)
 {
     NS_LOG_FUNCTION(this << nd << pLSA << &c);
 
-    auto plr = new GlobalRoutingLinkRecord;
+    auto plr = new GlobalRoutingLinkRecord<T>;
     NS_ABORT_MSG_IF(plr == nullptr,
                     "GlobalRouter::ProcessSingleBroadcastLink(): Can't alloc link record");
 
@@ -745,24 +858,43 @@
     //
     Ptr<Node> node = nd->GetNode();
 
-    Ptr<Ipv4> ipv4Local = node->GetObject<Ipv4>();
+    Ptr<Ip> ipLocal = node->GetObject<Ip>();
     NS_ABORT_MSG_UNLESS(
-        ipv4Local,
+        ipLocal,
         "GlobalRouter::ProcessSingleBroadcastLink (): GetObject for <Ipv4> interface failed");
 
-    int32_t interfaceLocal = ipv4Local->GetInterfaceForDevice(nd);
+    int32_t interfaceLocal = ipLocal->GetInterfaceForDevice(nd);
     NS_ABORT_MSG_IF(
         interfaceLocal == -1,
         "GlobalRouter::ProcessSingleBroadcastLink(): No interface index associated with device");
 
-    if (ipv4Local->GetNAddresses(interfaceLocal) > 1)
+    if (ipLocal->GetNAddresses(interfaceLocal) > 1)
     {
         NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the primary one");
     }
-    Ipv4Address addrLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetLocal();
-    Ipv4Mask maskLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetMask();
+    IpAddress addrLocal;
+    IpAddress addrLinkLocal; // this is the link local associated with the link for ipv6
+    if constexpr (IsIpv4)
+    {
+        addrLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+    }
+    else
+    {
+        addrLinkLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+        addrLocal = ipLocal->GetAddress(interfaceLocal, 1).GetAddress();
+    }
+
+    IpMaskOrPrefix maskLocal;
+    if constexpr (IsIpv4)
+    {
+        maskLocal = ipLocal->GetAddress(interfaceLocal, 0).GetMask();
+    }
+    else
+    {
+        maskLocal = ipLocal->GetAddress(interfaceLocal, 1).GetPrefix();
+    }
     NS_LOG_LOGIC("Working with local address " << addrLocal);
-    uint16_t metricLocal = ipv4Local->GetMetric(interfaceLocal);
+    uint16_t metricLocal = ipLocal->GetMetric(interfaceLocal);
 
     //
     // Check to see if the net device is connected to a channel/network that has
@@ -777,19 +909,35 @@
         // This is a net device connected to a stub network
         //
         NS_LOG_LOGIC("Router-LSA Stub Network");
-        plr->SetLinkType(GlobalRoutingLinkRecord::StubNetwork);
+        plr->SetLinkType(GlobalRoutingLinkRecord<T>::StubNetwork);
 
         //
         // According to OSPF, the Link ID is the IP network number of
         // the attached network.
         //
-        plr->SetLinkId(addrLocal.CombineMask(maskLocal));
+        if constexpr (IsIpv4)
+        {
+            plr->SetLinkId(addrLocal.CombineMask(maskLocal));
+        }
+        else
+        {
+            plr->SetLinkId(addrLocal.CombinePrefix(maskLocal));
+        }
 
         //
         // and the Link Data is the network mask; converted to Ipv4Address
         //
-        Ipv4Address maskLocalAddr;
-        maskLocalAddr.Set(maskLocal.Get());
+        IpAddress maskLocalAddr;
+        if constexpr (IsIpv4)
+        {
+            maskLocalAddr.Set(maskLocal.Get());
+        }
+        else
+        {
+            uint8_t buf[16];
+            maskLocal.GetBytes(buf);
+            maskLocalAddr.Set(buf);
+        }
         plr->SetLinkData(maskLocalAddr);
         plr->SetMetric(metricLocal);
         pLSA->AddLinkRecord(plr);
@@ -802,7 +950,7 @@
         // a transit network.
         //
         NS_LOG_LOGIC("Router-LSA Transit Network");
-        plr->SetLinkType(GlobalRoutingLinkRecord::TransitNetwork);
+        plr->SetLinkType(GlobalRoutingLinkRecord<T>::TransitNetwork);
 
         //
         // By definition, the router with the lowest IP address is the
@@ -811,17 +959,43 @@
         // case.
         //
         ClearBridgesVisited();
-        Ipv4Address designatedRtr;
+        IpAddress designatedRtr;
         designatedRtr = FindDesignatedRouterForLink(nd);
 
         //
         // Let's double-check that any designated router we find out on our
         // network is really on our network.
         //
-        if (designatedRtr != "255.255.255.255")
+        bool isRtrAllOnes = false;
+        if constexpr (IsIpv4)
+        {
+            if (designatedRtr.IsBroadcast())
+            {
+                isRtrAllOnes = true;
+            }
+        }
+        else
         {
-            Ipv4Address networkHere = addrLocal.CombineMask(maskLocal);
-            Ipv4Address networkThere = designatedRtr.CombineMask(maskLocal);
+            if (designatedRtr == Ipv6Address::GetOnes())
+            {
+                isRtrAllOnes = true;
+            }
+        }
+
+        if (!isRtrAllOnes)
+        {
+            IpAddress networkHere;
+            IpAddress networkThere;
+            if constexpr (IsIpv4)
+            {
+                networkHere = addrLocal.CombineMask(maskLocal);
+                networkThere = designatedRtr.CombineMask(maskLocal);
+            }
+            else
+            {
+                networkHere = addrLocal.CombinePrefix(maskLocal);
+                networkThere = designatedRtr.CombinePrefix(maskLocal);
+            }
             NS_ABORT_MSG_UNLESS(
                 networkHere == networkThere,
                 "GlobalRouter::ProcessSingleBroadcastLink(): Network number confusion ("
@@ -839,16 +1013,18 @@
         // OSPF says that the Link Data is this router's own IP address.
         //
         plr->SetLinkData(addrLocal);
+        plr->SetLinkLocData(addrLinkLocal);
         plr->SetMetric(metricLocal);
         pLSA->AddLinkRecord(plr);
         plr = nullptr;
     }
 }
 
+template <typename T>
 void
-GlobalRouter::ProcessBridgedBroadcastLink(Ptr<NetDevice> nd,
-                                          GlobalRoutingLSA* pLSA,
-                                          NetDeviceContainer& c)
+GlobalRouter<T>::ProcessBridgedBroadcastLink(Ptr<NetDevice> nd,
+                                             GlobalRoutingLSA<T>* pLSA,
+                                             NetDeviceContainer& c)
 {
     NS_LOG_FUNCTION(this << nd << pLSA << &c);
     NS_ASSERT_MSG(nd->IsBridge(),
@@ -876,18 +1052,37 @@
   // associated to them.
   //
   Ptr<Node> node = nd->GetNode ();
-  Ptr<Ipv4> ipv4Local = node->GetObject<Ipv4> ();
+  Ptr<Ip> ipLocal = node->GetObject<Ip> ();
   NS_ABORT_MSG_UNLESS (ipv4Local, "GlobalRouter::ProcessBridgedBroadcastLink (): GetObject for <Ipv4> interface failed");
 
-  int32_t interfaceLocal = ipv4Local->GetInterfaceForDevice (nd);
+  int32_t interfaceLocal = ipLocal->GetInterfaceForDevice (nd);
   NS_ABORT_MSG_IF (interfaceLocal == -1, "GlobalRouter::ProcessBridgedBroadcastLink(): No interface index associated with device");
 
-  if (ipv4Local->GetNAddresses (interfaceLocal) > 1)
+  if (ipLocal->GetNAddresses (interfaceLocal) > 1)
     {
       NS_LOG_WARN ("Warning, interface has multiple IP addresses; using only the primary one");
     }
-  Ipv4Address addrLocal = ipv4Local->GetAddress (interfaceLocal, 0).GetLocal ();
-  Ipv4Mask maskLocal = ipv4Local->GetAddress (interfaceLocal, 0).GetMask ();
+   IpAddress addrLocal;
+    IpAddress addrLinkLocal; // this is the link local associated with the link for ipv6
+    if constexpr (IsIpv4)
+    {
+        addrLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+    }
+    else
+    {
+        addrLinkLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+        addrLocal = ipLocal->GetAddress(interfaceLocal, 1).GetAddress();
+    }
+
+    IpMaskOrPrefix maskLocal;
+    if constexpr (IsIpv4)
+    {
+        maskLocal = ipLocal->GetAddress(interfaceLocal, 0).GetMask();
+    }
+    else
+    {
+        maskLocal = ipLocal->GetAddress(interfaceLocal, 1).GetPrefix();
+    }
   NS_LOG_LOGIC ("Working with local address " << addrLocal);
   uint16_t metricLocal = ipv4Local->GetMetric (interfaceLocal);
 
@@ -901,7 +1096,7 @@
   //
 
   bool areTransitNetwork = false;
-  Ipv4Address designatedRtr ("255.255.255.255");
+  IpAddress designatedRtr;
 
   for (uint32_t i = 0; i < bnd->GetNBridgePorts (); ++i)
     {
